/**
 * Created May 5, 2022
 */

#ifndef ESP_Line_Notify_Error_H
#define ESP_Line_Notify_Error_H

#pragma once

#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_UNDEFINED -1000
#define ESP_LINE_NOTIFY_ERROR_RANGE -100

/// TCP client errors
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_CONNECTION_REFUSED (-1)
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_SEND_REQUEST_FAILED (-2)
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_NOT_CONNECTED (-3)
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_CONNECTION_LOST (-4)
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_NO_STREAM (-5)
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_NO_HTTP_SERVER (-6)
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_TOO_LESS_RAM (-7)
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_ENCODING (-8)
#define ESP_LINE_NOTIFY_ERROR_TCP_ERROR_STREAM_WRITE (-9)
#define ESP_LINE_NOTIFY_ERROR_TCP_RESPONSE_PAYLOAD_READ_TIMED_OUT (-10)
#define ESP_LINE_NOTIFY_ERROR_TCP_RESPONSE_READ_FAILED (-11)
#define ESP_LINE_NOTIFY_ERROR_EXTERNAL_CLIENT_DISABLED (-12)
#define ESP_LINE_NOTIFY_ERROR_EXTERNAL_CLIENT_NOT_INITIALIZED (-13)

/// HTTP codes see RFC7231
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_OK 200
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_NON_AUTHORITATIVE_INFORMATION 203
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_NO_CONTENT 204
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_MOVED_PERMANENTLY 301
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_FOUND 302
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_USE_PROXY 305
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_TEMPORARY_REDIRECT 307
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_PERMANENT_REDIRECT 308
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_BAD_REQUEST 400
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_UNAUTHORIZED 401
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_FORBIDDEN 403
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_NOT_FOUND 404
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_METHOD_NOT_ALLOWED 405
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_NOT_ACCEPTABLE 406
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_PROXY_AUTHENTICATION_REQUIRED 407
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_REQUEST_TIMEOUT 408
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_LENGTH_REQUIRED 411
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_PRECONDITION_FAILED 412
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_PAYLOAD_TOO_LARGE 413
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_URI_TOO_LONG 414
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_MISDIRECTED_REQUEST 421
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_UNPROCESSABLE_ENTITY 422
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_TOO_MANY_REQUESTS 429
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_REQUEST_HEADER_FIELDS_TOO_LARGE 431
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_INTERNAL_SERVER_ERROR 500
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_NOT_IMPLEMENTED 501
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_BAD_GATEWAY 502
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_SERVICE_UNAVAILABLE 503
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_GATEWAY_TIMEOUT 504
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_HTTP_VERSION_NOT_SUPPORTED 505
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_LOOP_DETECTED 508
#define ESP_LINE_NOTIFY_ERROR_HTTP_CODE_NETWORK_AUTHENTICATION_REQUIRED 511

#endif